diff -urNb aodv-uu-0.7.2/maodv_neighbor.h maodv-umd-0.7.2/maodv_neighbor.h
--- aodv-uu-0.7.2/maodv_neighbor.h	Wed Dec 31 19:00:00 1969
+++ maodv-umd-0.7.2/maodv_neighbor.h	Wed Jun 25 17:46:10 2003
@@ -0,0 +1,38 @@
+/*****************************************************************************
+ *
+ * Copyright (C) 2003 CSHCN, University of Maryland.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Dionysus Blazakis <dblaze@umd.edu>
+ *          Jonathan Polley <jpolley@umd.edu>
+ *          Dan Rusk <drusk@umd.edu>
+ *          Manish Karir <karir@umd.edu>
+ *
+ *****************************************************************************/
+
+#ifndef MAODV_NEIGHBOR_H
+#define MAODV_NEIGHBOR_H
+
+#include "routing_table.h"
+#include "multicast_routing_table.h"
+
+void mcast_neighbor_link_break(rt_table_t *rt);
+/* mcast_prune_dangle
+ * if you become a router only with no downstream nodes, (dangling) then
+ * prune self after a timeout */
+void mcast_prune_dangle( mrt_table_t *mrt );
+
+#endif
diff -urNb aodv-uu-0.7.2/maodv_rrep.c maodv-umd-0.7.2/maodv_rrep.c
--- aodv-uu-0.7.2/maodv_rrep.c	Wed Dec 31 19:00:00 1969
+++ maodv-umd-0.7.2/maodv_rrep.c	Wed Jun 25 17:46:10 2003
@@ -0,0 +1,191 @@
+#ifdef MAODV
+
+/*****************************************************************************
+ *
+ * Copyright (C) 2003 CSHCN, University of Maryland.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Dionysus Blazakis <dblaze@umd.edu>
+ *          Jonathan Polley <jpolley@umd.edu>
+ *          Dan Rusk <drusk@umd.edu>
+ *          Manish Karir <karir@umd.edu>
+ *
+ *****************************************************************************/
+
+#include "defs.h"
+#include "debug.h"
+#include "maodv_rrep.h"
+#include "routing_table.h"
+#include "multicast_routing_table.h"
+#include "aodv_socket.h"
+#include "aodv_rreq.h"
+#include "aodv_rrep.h"
+#include "packet_queue.h"
+
+/*
+ *  maodv_rrep_process( lots of stuff )
+ *  Processes an rrep that has already been sanity checked and is
+ *  responding to a multicast group.
+ */
+void maodv_rrep_process( RREP *rrep, int rreplen, u_int32_t ip_src,  
+    u_int32_t ip_dst, int ip_ttl, unsigned int ifindex, int size )
+{
+    mrt_nexthop_t * upstream;
+    mrt_table_t * mrt;
+    rt_table_t * rev_rt;
+    u_int32_t rrep_orig, rrep_dest, rrep_seqno, rrep_lifetime;
+    mrt_orig_t *orig;
+    
+    DEBUG( LOG_DEBUG, 0, "Inside RREP process." );
+
+    rrep_dest = ntohl(rrep->dest_addr);
+    rrep_seqno = ntohl(rrep->dest_seqno);
+    rrep_orig = ntohl(rrep->orig_addr);
+    rrep_lifetime = ntohl(rrep->lifetime);
+
+    rev_rt = rt_table_find( rrep_orig );
+    mrt = mrt_table_find( rrep_dest );
+
+    if ( !mrt ) {
+        log(LOG_WARNING, 0, __FUNCTION__,
+            "No multicast route to group %s found in RREP.",
+            ip_to_str( rrep_dest ) );
+        return;
+    }
+
+    upstream = mrt_nexthop_find(mrt, ip_src);
+    if(upstream == NULL){
+        DEBUG( LOG_DEBUG, 0, "Created nexthop." );
+        upstream = mrt_nexthop_add( mrt, ip_src, MRT_UPSTREAM, rrep_seqno );
+    } else {
+        /* update seqno */
+        DEBUG( LOG_DEBUG, 0, "Had nexthop, updated seqno." );
+        upstream->grp_seqno = rrep_seqno;
+    }
+    
+    /* add the originator to the originator list if not there already */
+    orig=mrt_origlist_find(mrt, rrep_orig);
+    if(orig==NULL){
+        DEBUG(LOG_DEBUG, 0, "originator not in list, adding");
+        orig=mrt_origlist_add(mrt, rrep_orig);
+    }
+ 
+    DEBUG(LOG_DEBUG, 0, "originator seqno: %d hcnt: %d", orig->grp_seqno, 
+        orig->grp_hcnt);
+
+    /* rrep is propagated if the prior rreq had a lower
+       sequence number or the sequence numbers are equal and the
+       incoming rrep has a smaller hopcount */ 
+    if ( ( ( orig->grp_seqno < rrep_seqno ) ||
+           ( ( orig->grp_seqno == rrep_seqno ) &&
+             ( orig->grp_hcnt > rrep->hcnt ) ) ) ){
+
+        DEBUG( LOG_DEBUG, 0, "Forwardable/acceptable rrep." );
+
+        mrt->grp_seqno = rrep_seqno;
+        orig->grp_seqno=rrep_seqno;
+        orig->grp_hcnt = rrep->hcnt;
+
+        if ( !upstream->activated ) {
+            upstream->direction = MRT_UPSTREAM;
+            upstream->grp_hcnt = rrep->hcnt;
+        }
+        
+        if ( rrep_orig != DEV_IFINDEX(ifindex).ipaddr )
+            maodv_rrep_forward( rrep, rev_rt, mrt, --ip_ttl, size );
+    } else {
+        DEBUG( LOG_DEBUG, 0,"mrt->grp_seqno: %d\trrep_seqno: %d", 
+            mrt->grp_seqno, rrep_seqno );
+    }
+}
+
+void maodv_rrep_forward( RREP * rrep, rt_table_t * rev_rt,
+    mrt_table_t * fwd_rt, int ttl, int size )
+{
+    mrt_nexthop_t * upstream;
+
+    if (!fwd_rt || !rev_rt) {
+        DEBUG(LOG_WARNING, 0, "Could not forward RERR because of NULL route!");
+        return;
+    }
+
+    if (!rrep) {
+        DEBUG(LOG_WARNING, 0, "No RREP to forward!");
+        return;
+    }
+
+    DEBUG(LOG_DEBUG, 0, "Forwarding RREP to %s", ip_to_str(rev_rt->next_hop));
+
+    rrep = (RREP *) aodv_socket_queue_msg((AODV_msg *) rrep, size);
+    upstream = mrt_table_get_best_upstream( fwd_rt );
+    
+    /* Update the hopcount */
+    if(!fwd_rt->is_router){
+        rrep->hcnt++;
+    }
+
+    aodv_socket_send((AODV_msg *) rrep, rev_rt->next_hop, size, ttl,
+                     &DEV_IFINDEX(rev_rt->ifindex));
+
+    /* TODO: timing code... */
+/*    rt_table_update_timeout(rev_rt, ACTIVE_ROUTE_TIMEOUT); */
+}
+
+void maodv_rrep_send( rt_table_t * rev_rt, mrt_table_t * fwd_rt )
+{
+    RREP *rrep;
+    u_int8_t rrep_flags = 0;
+    u_int32_t dest, lifetime;
+    int hcnt;
+
+    /* CHECK: we do not use this... */
+    lifetime = 0x0ffffffff;
+
+    if (!rev_rt) {
+        DEBUG(LOG_WARNING, 0, "Can't send RREP, rev_rt = NULL!");
+        return;
+    }
+
+    if (!fwd_rt) {
+        DEBUG(LOG_WARNING, 0, "Can't send RREP, fwd_rt = NULL!");
+        return;
+    }
+
+    DEBUG(LOG_DEBUG, 0, "[maodv] sending rrep.");
+
+    dest = fwd_rt->grp_addr;
+
+    hcnt = 0;
+
+    /* TODO: timeout code... */
+    /*
+    gettimeofday(&now, NULL);
+    lifetime = timeval_diff(&fwd_rt->rt_timer.timeout, &now);
+    */
+
+    DEBUG(LOG_DEBUG, 0, "[maodv] Sending RREP to %s about %s->%s",
+          ip_to_str(rev_rt->next_hop), ip_to_str(rev_rt->dest_addr),
+          ip_to_str(dest));
+
+    rrep = rrep_create(rrep_flags, 0, hcnt, dest, fwd_rt->grp_seqno, 
+        rev_rt->dest_addr, lifetime, 0 );
+        
+    aodv_socket_send((AODV_msg *) rrep, rev_rt->next_hop, RREP_SIZE, MAXTTL,
+                     &DEV_IFINDEX(rev_rt->ifindex));
+
+}
+
+#endif /* MAODV */
diff -urNb aodv-uu-0.7.2/maodv_rrep.h maodv-umd-0.7.2/maodv_rrep.h
--- aodv-uu-0.7.2/maodv_rrep.h	Wed Dec 31 19:00:00 1969
+++ maodv-umd-0.7.2/maodv_rrep.h	Wed Jun 25 17:46:10 2003
@@ -0,0 +1,41 @@
+/*****************************************************************************
+ *
+ * Copyright (C) 2003 CSHCN, University of Maryland.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Dionysus Blazakis <dblaze@umd.edu>
+ *          Jonathan Polley <jpolley@umd.edu>
+ *          Dan Rusk <drusk@umd.edu>
+ *          Manish Karir <karir@umd.edu>
+ *
+ *****************************************************************************/
+
+#ifndef MAODV_RREP_H
+#define MAODV_RREP_H
+
+#include "routing_table.h"
+#include "multicast_routing_table.h"
+#include "aodv_rrep.h"
+
+void maodv_rrep_process( RREP *rrep, int rreplen, u_int32_t ip_src,  
+    u_int32_t ip_dst, int ip_ttl, unsigned int ifindex, int size );
+
+void maodv_rrep_forward( RREP * rrep, rt_table_t * rev_rt,
+    mrt_table_t * fwd_rt, int ttl, int size );
+
+void maodv_rrep_send( rt_table_t * rev_rt, mrt_table_t * fwd_rt );
+
+#endif
diff -urNb aodv-uu-0.7.2/maodv_rreq.c maodv-umd-0.7.2/maodv_rreq.c
--- aodv-uu-0.7.2/maodv_rreq.c	Wed Dec 31 19:00:00 1969
+++ maodv-umd-0.7.2/maodv_rreq.c	Wed Jun 25 17:46:10 2003
@@ -0,0 +1,175 @@
+#ifdef MAODV
+
+/*****************************************************************************
+ *
+ * Copyright (C) 2003 CSHCN, University of Maryland.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Dionysus Blazakis <dblaze@umd.edu>
+ *          Jonathan Polley <jpolley@umd.edu>
+ *          Dan Rusk <drusk@umd.edu>
+ *          Manish Karir <karir@umd.edu>
+ *
+ *****************************************************************************/
+
+#include "defs.h"
+#include "debug.h"
+#include "maodv_rreq.h"
+#include "maodv_rrep.h"
+#include "multicast_routing_table.h"
+#include "aodv_socket.h"
+#include "aodv_rreq.h"
+#include "aodv_rrep.h"
+#include "maodv_ext.h"
+
+/*
+ *  maodv_rreq_process( lots of stuff )
+ *  Processes an rreq that has already been sanity checked and is
+ *  headed for a multicast group.
+ */
+void maodv_rreq_process( RREQ *rreq, int rreqlen, u_int32_t ip_src,  
+    u_int32_t ip_dst, int ip_ttl, unsigned int ifindex, 
+    GRP_REBUILD_EXT *grb_ext, int size )
+{
+    mrt_table_t * mrt;
+    rt_table_t * rev_rt;
+    u_int32_t rreq_orig, rreq_dest, rreq_orig_seqno, rreq_dest_seqno;
+    u_int32_t rreq_id, rreq_new_hcnt;
+    mrt_nexthop_t * nh;
+    mrt_orig_t *orig;
+    
+    DEBUG( LOG_DEBUG, 0, "Inside RREP process." );
+
+    rreq_id = ntohl(rreq->rreq_id);
+    rreq_dest = ntohl(rreq->dest_addr);
+    rreq_dest_seqno = ntohl(rreq->dest_seqno);
+    rreq_orig = ntohl(rreq->orig_addr);
+    rreq_orig_seqno = ntohl(rreq->orig_seqno);
+    rreq_new_hcnt = rreq->hcnt + 1;
+
+    mrt = mrt_table_find( rreq_dest );
+    if ( mrt==NULL ) {
+        /* no route found */
+        DEBUG(LOG_DEBUG, 0, "MRREQ: No mrt found." );
+        mrt = mrt_table_insert( rreq_dest, 0, rreq_dest_seqno, 
+            ifindex, 255, 0 );
+    }
+
+    /* add nexthop downstream */
+    nh = mrt_nexthop_find( mrt, rreq_orig );
+    if ( nh == NULL ) {
+        mrt_nexthop_add( mrt, ip_src, MRT_DOWNSTREAM, rreq_dest_seqno );
+    }
+
+    /* add the originator to the originator list if not there already */
+    orig=mrt_origlist_find(mrt, rreq_orig);
+    if(orig==NULL){
+        DEBUG(LOG_DEBUG, 0, "originator not in list, adding");
+        orig=mrt_origlist_add(mrt, rreq_orig);
+    }
+    DEBUG(LOG_DEBUG, 0, "originator seqno: %d hcnt: %d", orig->grp_seqno, orig->grp_hcnt);
+
+    if ( rreq->j ) {
+        /* a Join request */
+        DEBUG(LOG_DEBUG, 0, "MRREQ: [j] Join." );
+
+        if ( !mrt->is_router) {
+            DEBUG(LOG_DEBUG, 0, "MRREQ: [j] Found a mrt, but not on the tree.");
+        } else if ( mrt->grp_seqno < rreq_dest_seqno ) {
+            DEBUG(LOG_DEBUG, 0, "MRREQ: [j] Found a mrt, but it is old. %d < %d", mrt->grp_seqno, rreq_dest_seqno );
+            mrt->grp_seqno = rreq_dest_seqno;
+        } else {
+            if(grb_ext==NULL || mrt->leader_hcnt<=grb_ext->grp_hcnt){
+                DEBUG(LOG_DEBUG, 0, "MRREQ: [j] Should send RREP!" );
+
+                /* send rrep */
+                rev_rt = rt_table_find( rreq_orig );
+                orig->grp_seqno=mrt->grp_seqno;
+                orig->grp_hcnt=0;
+                maodv_rrep_send( rev_rt, mrt );
+
+                /* done! get out */
+                return; 
+            }else{
+                DEBUG(LOG_DEBUG, 0, "had repair extension, bad hopcount, do nothing");
+            }
+        }
+    } else {
+        /* non-Join request */
+        DEBUG(LOG_DEBUG, 0, "MRREQ: [] non-Join." );
+
+        if ( mrt->grp_seqno < rreq_dest_seqno ) {
+            DEBUG(LOG_DEBUG, 0, "MRREQ: [] Found a mrt, but it is old." );
+            /* update sequence number in our table */
+            mrt->grp_seqno = rreq_dest_seqno;
+        } else if ( mrt->is_router ) {
+            DEBUG(LOG_DEBUG, 0, "MRREQ: [] Should send RREP!" );
+
+            /* send rrep */
+            rev_rt = rt_table_find( rreq_orig );
+            orig->grp_seqno=mrt->grp_seqno;
+            orig->grp_hcnt=0;
+            maodv_rrep_send( rev_rt, mrt );
+
+            /* we're done! */
+            return;
+        }
+    }
+
+    /* if we get this far, no RREP has been sent. */
+
+    /* now, forward RREQ */
+    /* if rreq has unknown seqno and our table has a known one
+       (not zero), then update packet seqno field. or if ours
+       is just bigger.
+       CHECK: this may not be the way to do this */
+    if ( ( mrt->grp_seqno > rreq_dest_seqno ) || 
+         ( rreq->u && mrt->grp_seqno ) ) {
+        rreq->u = 0;
+        rreq->dest_seqno = htonl( mrt->grp_seqno );
+    }
+
+   /* send it back out */
+   maodv_rreq_forward( rreq, --ip_ttl, size );
+}
+
+/*
+ *  maodv_rreq_forward( RREQ * rreq, int ttl, int size )
+ *  Forwards a route request.
+ */
+void maodv_rreq_forward( RREQ * rreq, int ttl, int size )
+{
+    int i;
+    /* FORWARD the RREQ if the TTL allows it. */
+    DEBUG(LOG_DEBUG, 0, "[maodv] forwarding RREQ src=%s, rreq_id=%lu",
+          ip_to_str(ntohl(rreq->orig_addr)), ntohl(rreq->rreq_id));
+            
+    /* Queue the received message in the send buffer */
+    rreq = (RREQ *) aodv_socket_queue_msg((AODV_msg *) rreq, size);
+     
+    rreq->hcnt++;               /* Increase hopcount to account for
+                                 * intermediate route */
+
+    /* Send out on all interfaces */
+    for (i = 0; i < MAX_NR_INTERFACES; i++) {
+        if (!DEV_NR(i).enabled)
+            continue;
+        aodv_socket_send((AODV_msg *) rreq, AODV_BROADCAST, size, ttl,
+                         &DEV_NR(i));
+    }
+}
+
+#endif /* MAODV */
diff -urNb aodv-uu-0.7.2/maodv_rreq.h maodv-umd-0.7.2/maodv_rreq.h
--- aodv-uu-0.7.2/maodv_rreq.h	Wed Dec 31 19:00:00 1969
+++ maodv-umd-0.7.2/maodv_rreq.h	Wed Jun 25 17:46:10 2003
@@ -0,0 +1,39 @@
+/*****************************************************************************
+ *
+ * Copyright (C) 2003 CSHCN, University of Maryland.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Dionysus Blazakis <dblaze@umd.edu>
+ *          Jonathan Polley <jpolley@umd.edu>
+ *          Dan Rusk <drusk@umd.edu>
+ *          Manish Karir <karir@umd.edu>
+ *
+ *****************************************************************************/
+
+#ifndef MAODV_RREQ_H
+#define MAODV_RREQ_H
+
+#include "defs.h"
+#include "aodv_rreq.h"
+#include "maodv_ext.h"
+
+void maodv_rreq_process( RREQ *rreq, int rreqlen, u_int32_t ip_src,
+    u_int32_t ip_dst, int ip_ttl, unsigned int ifindex, 
+    GRP_REBUILD_EXT *grb_ext, int size );
+
+void maodv_rreq_forward( RREQ * rreq, int ttl, int size );
+
+#endif /* MAODV_RREQ_H */
diff -urNb aodv-uu-0.7.2/multicast_packet_cache.c maodv-umd-0.7.2/multicast_packet_cache.c
--- aodv-uu-0.7.2/multicast_packet_cache.c	Wed Dec 31 19:00:00 1969
+++ maodv-umd-0.7.2/multicast_packet_cache.c	Wed Jun 25 17:46:10 2003
@@ -0,0 +1,80 @@
+#ifdef MAODV
+
+/*****************************************************************************
+ *
+ * Copyright (C) 2003 CSHCN, University of Maryland.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * 
+ * Authors: Matthew Impett <m.impett@flarion.com>
+ *
+ *
+ *****************************************************************************/
+ 
+#include "multicast_packet_cache.h"
+
+void	init_packet_cache(void)
+{
+	int i;
+	int j;
+	for(i=0; i< HASHBUCKETS; i++)
+	{
+		packet_cache[i].packet_cache_write_index = 0;
+		for(j=0; j < MAX_PACKET_CACHE; j++)
+		{
+			packet_cache[i].ip_src[j] = 0;
+			packet_cache[i].ip_id[j] = 0;
+			packet_cache[i].ip_hook[j] = 0;
+		}
+	}
+}
+
+/* This function returns 1 if a duplicate packet has not been
+   found and  returns 0 if a duplicate packet has not been found and adds 
+   that packet to the packet cache. */
+int	check_duplicate(u_int32_t src, u_int16_t id, u_int8_t hook)
+{	
+	u_int8_t	hash_value;
+	int i;
+	int j = 0;
+	hash_value = 	packet_hashfunction(src);
+
+	for(i=0; i< MAX_PACKET_CACHE; i++)
+	{
+		if( (packet_cache[hash_value].ip_src[i] == src) &&
+                    (packet_cache[hash_value].ip_id[i] == id) &&
+		    (packet_cache[hash_value].ip_hook[i] == hook) )
+		{
+			/* Found a duplicate packet.... Drop it */
+			return 0;
+		}
+	}
+
+	/* Not found the packet in the cache... Add it to the packet cache */
+
+	j = packet_cache[hash_value].packet_cache_write_index ;	
+	packet_cache[hash_value].ip_src[j] = src;
+	packet_cache[hash_value].ip_id[j] = id;
+	packet_cache[hash_value].ip_hook[j] = hook;
+	packet_cache[hash_value].packet_cache_write_index = (j+1)%(MAX_PACKET_CACHE);
+	return 1;	
+}
+
+u_int8_t	packet_hashfunction(u_int32_t addr)
+{
+	return ((addr >> 24) % HASHBUCKETS);
+}
+
+#endif /* MAODV */
diff -urNb aodv-uu-0.7.2/multicast_packet_cache.h maodv-umd-0.7.2/multicast_packet_cache.h
--- aodv-uu-0.7.2/multicast_packet_cache.h	Wed Dec 31 19:00:00 1969
+++ maodv-umd-0.7.2/multicast_packet_cache.h	Wed Jun 25 17:46:10 2003
@@ -0,0 +1,54 @@
+/*****************************************************************************
+ *
+ * Copyright (C) 2003 CSHCN, University of Maryland.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Matthew Impett <m.impett@flarion.com>
+ *
+ *
+ *****************************************************************************/
+
+/**********************************************************************
+   The following packet cache has been obtained from Matthew Impett's 
+   TORA implementation code.....  
+ **********************************************************************/
+
+#ifndef MULTICAST_PACKET_CACHE_H
+#define MULTICAST_PACKET_CACHE_H
+
+#include "defs.h"
+
+#define HASHBUCKETS             10   /* number of buckets for entries */
+#define MAX_PACKET_CACHE        10   /* # of packets for each hash bucket */
+
+/* This structure is used to hold a little cache of recently forwarded 
+   packets which we can use to detect duplicate packets. */
+struct pack_cache
+{
+        u_int32_t  	ip_src[MAX_PACKET_CACHE];
+        u_int16_t	ip_id[MAX_PACKET_CACHE];
+	u_int8_t	ip_hook[MAX_PACKET_CACHE];
+	int		packet_cache_write_index;
+};
+
+struct pack_cache packet_cache[HASHBUCKETS];
+void    init_packet_cache(void);
+u_int8_t	packet_hashfunction(u_int32_t addr);
+int		check_duplicate(u_int32_t source, u_int16_t id, 
+    u_int8_t hook);
+
+#endif /* MULTICAST_PACKET_CACHE_H */
+
